var Web3 = require('web3');
var web3 = new Web3();

var verosContract;
var verosInstance;

var coinbaseAddress;
var coinbasePassword;

function connectToGeth(ip,address,password) {
    web3.setProvider(new web3.providers.HttpProvider(ip));

    verosContract = web3.eth.contract([{"constant":false,"inputs":[{"name":"_spender","type":"address"},{"name":"_value","type":"uint256"}],"name":"approve","outputs":[{"name":"success","type":"bool"}],"payable":false,"type":"function"},{"constant":true,"inputs":[],"name":"totalSupply","outputs":[{"name":"totalSupply","type":"uint256"}],"payable":false,"type":"function"},{"constant":false,"inputs":[{"name":"_from","type":"address"},{"name":"_to","type":"address"},{"name":"_value","type":"uint256"}],"name":"transferFrom","outputs":[{"name":"success","type":"bool"}],"payable":false,"type":"function"},{"constant":false,"inputs":[{"name":"receivingAddress","type":"address"},{"name":"ownerAddress","type":"address"}],"name":"addReceivingAddress","outputs":[],"payable":false,"type":"function"},{"constant":true,"inputs":[{"name":"receivingAddress","type":"address"}],"name":"getReceivingAddressOwner","outputs":[{"name":"ownerAddress","type":"address"}],"payable":false,"type":"function"},{"constant":true,"inputs":[{"name":"_owner","type":"address"}],"name":"balanceOf","outputs":[{"name":"balance","type":"uint256"}],"payable":false,"type":"function"},{"constant":false,"inputs":[{"name":"senderAddress","type":"address"},{"name":"recipientAddress","type":"address"},{"name":"amount","type":"uint256"}],"name":"registerInternalTransaction","outputs":[],"payable":false,"type":"function"},{"constant":true,"inputs":[],"name":"availableSupply","outputs":[{"name":"availableSupply","type":"uint256"}],"payable":false,"type":"function"},{"constant":false,"inputs":[{"name":"_to","type":"address"},{"name":"_value","type":"uint256"}],"name":"transfer","outputs":[{"name":"success","type":"bool"}],"payable":false,"type":"function"},{"constant":true,"inputs":[{"name":"_owner","type":"address"},{"name":"_spender","type":"address"}],"name":"allowance","outputs":[{"name":"remaining","type":"uint256"}],"payable":false,"type":"function"},{"inputs":[],"type":"constructor"},{"anonymous":false,"inputs":[{"indexed":true,"name":"_from","type":"address"},{"indexed":true,"name":"_to","type":"address"},{"indexed":true,"name":"_receivingAddress","type":"address"},{"indexed":false,"name":"_value","type":"uint256"},{"indexed":false,"name":"_internalTransaction","type":"bool"}],"name":"Transfer","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"_owner","type":"address"},{"indexed":true,"name":"_spender","type":"address"},{"indexed":false,"name":"_value","type":"uint256"}],"name":"Approval","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"recipientAddress","type":"address"},{"indexed":true,"name":"ownerAddress","type":"address"}],"name":"RegisterReceivingAddress","type":"event"}]);
    verosInstance = verosContract.at("0x01c196f4f791ea5b3e612d90c2e305991976b73f");

    coinbaseAddress = address;
    coinbasePassword = password;
}

function getBlockNumber() {
    return web3.eth.blockNumber;
}

function createAccount(password) {
    return web3.personal.newAccount(password);
}


function checkAccount(address,password) {
    try {
        return web3.personal.unlockAccount(address.slice(2), password);
    } catch (err) {
        return false;
    }
}
function getVerosBalance(address) {
    return balance = verosInstance.balanceOf.call(address);
}

function listAccounts() {
    return web3.eth.accounts;
}

function sendVeros(fromAddress, fromPassword, recipientAddress,amount,completion) {
    if (!checkAccount(fromAddress,fromPassword)) {
        return completion("Cannot unlock sender account",null);
    }
    if (getVerosBalance(fromAddress) < (amount + 3000)) {
        return completion("Insufficient amount",null);
    }
    try {
        verosInstance.transfer(recipientAddress, amount, {
            from: fromAddress
        }, function (err, tx) {
            completion(err, tx);
        });
    } catch (err) {
        completion(err,null);
    }
}

module.exports = {
    connectToGeth:connectToGeth,
    getVerosBalance:getVerosBalance,
    getBlockNumber:getBlockNumber,

    createAccount:createAccount,
    checkAccount:checkAccount,
    sendVeros:sendVeros,
    listAccounts:listAccounts,

    web3:web3
};
